#include <Wire.h>
#include <Adafruit_INA219.h>
#include <Adafruit_SSD1306.h>
Adafruit_INA219 ina219;

#define OLED_RESET 4
Adafruit_SSD1306 display(OLED_RESET);

float shuntvoltage = 0;
float busvoltage = 0;
float current_mA = 0;
float power_mW = 0;
int button  =  D0;
const int ledPin =  D6;      // LED connected to digital pin D6
const int ledPin1 =  D2;  
const int ledPin2 =  D3; 
int initial = 0;
int oldstate = 0;
int buttonstate = 0; 


void setup() {

  // initialize ina219 with default measurement range of 32V, 2A
  ina219.begin();

  // ina219.setCalibration_32V_2A();    // set measurement range to 32V, 2A  (do not exceed 26V!)
  // ina219.setCalibration_32V_1A();    // set measurement range to 32V, 1A  (do not exceed 26V!)
  ina219.setCalibration_16V_400mA(); // set measurement range to 16V, 400mA

  // initialize OLED display
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
  display.clearDisplay();
   display.clearDisplay();
  display.setTextSize(1);
  display.setTextColor(WHITE);
 display.setCursor(0, 4);
//   Display static text
 display.println("WELCOME TO ");
  display.setCursor(0, 15);
display.println(" FAB ACADEMY 2023");
 display.display();
   pinMode(ledPin, OUTPUT);
    pinMode(ledPin1, OUTPUT);
      pinMode(ledPin2, OUTPUT);
  pinMode(button, INPUT);

}

void loop() {

  // read data from ina219
  shuntvoltage = ina219.getShuntVoltage_mV();
  busvoltage = ina219.getBusVoltage_V();
  current_mA = ina219.getCurrent_mA();
  power_mW = ina219.getPower_mW();

  buttonstate = digitalRead(button);
  if (buttonstate == HIGH)
  {
 delay (50);
   buttonstate = digitalRead(button);
   if (buttonstate == LOW)
  initial = oldstate + 1;
  }
  else
  {
    delay(100);
  }
  switch (initial)
  {
  case 1:
  digitalWrite(ledPin2,LOW);

 digitalWrite(ledPin, LOW); 
 digitalWrite(ledPin1, HIGH);
 
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.setCursor(0, 0);
  //Display static text
  display.println("Sugar");
  display.setCursor(0,17);
    display.println("Syrup");
   if(54<-current_mA>58)
 {
    digitalWrite(ledPin, HIGH);
      display.clearDisplay();
  display.setTextSize(3);
  display.setTextColor(WHITE);
 display.setCursor(0, 5);
//   Display static text
 display.println("READY");
 display.display();
 // display.clearDisplay(); 
 }
  else
  {
    digitalWrite(ledPin, LOW);
    }
  
  display.display();
   display.clearDisplay(); 
 
 
  oldstate = initial;
  break;
   case 2:
 
 digitalWrite(ledPin2, HIGH);

 digitalWrite(ledPin, LOW); 
 digitalWrite(ledPin1, LOW);
            display.setTextSize(2);
  display.setTextColor(WHITE);
  display.setCursor(0,0);
  // Display static text
  display.println("Tomoto");
 display.setCursor(0,17);
  // Display static text
  display.println("Soup");
 
   //display.clearDisplay(); 
  if(58<-current_mA<60)
  {
    delay(50);
    digitalWrite(ledPin, HIGH);
 
      display.clearDisplay();
                display.setTextSize(2.5);
  display.setTextColor(WHITE);
  display.setCursor(0, 5);
  // Display static text
  display.println("READY");
    display.display();
    delay(1000);
  //display.clearDisplay(); 
  }
  else
  {
    digitalWrite(ledPin, LOW);
    }
  
  display.display();
   display.clearDisplay(); 
 
  oldstate = initial;
  break;

  case 3:
 
  digitalWrite(ledPin, LOW);
   display.setTextSize(2);
  display.setTextColor(WHITE);
  display.setCursor(0,0);
  // Display static text
  display.println("Current");
 display.setCursor(0,17);
  // Display static text
  display.println(-current_mA);
 display.setCursor(70,17);
    display.println("mA");
    delay(2000);
     display.display();
   display.clearDisplay(); 
 
  oldstate = initial;
  break;
  
  
  default:
   digitalWrite(ledPin, LOW);
        digitalWrite(ledPin1, LOW);
            digitalWrite(ledPin2, LOW);
 
  oldstate = 0;
  break;
    

}

}
